/* DuduSDL
 * dudusdl_1.c
 *
 * Copyright (C) 2000 Nicolas Peninguy and Colin Leroy
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "dudusdl.h"

extern SDL_Rect * trect;

int LoadPic(const char *nom, int num)
{
  assert( ((num >= 0) & (num <= NB_IMAGES)) );
  
  if (! (images[num] = IMG_Load(nom)))
    return 1;
  return 0;
}


void Quit(const char *message)
{
  fprintf(stderr, message);
  exit(1);
}

void PutPicM(unsigned int num, int x, int y)
{
  SDL_BlitSurface(images[num], NULL, screen, NULL);
  //SDL_UpdateRect(screen, 0, 0, 0, 0);
}

void PutPic(unsigned int num, int x, int y)
{
  trect->x = x;
  trect->y = y;
  SDL_BlitSurface(images[num], NULL, screen, trect);
}

void clearbuffer(SDL_Surface *s, Uint8 color)
{
  assert( (s->format->BytesPerPixel == 1) );
  //  assert( (color >= 0 && color < 256) ); Toujours vrai du fait du type de donne.
  
  if (SDL_MUSTLOCK(s))
    if (SDL_LockSurface(s) < 0)
      return;
  memset((Uint8 *)s->pixels, (int)color, (size_t)((s->w)*(s->h)));

  if (SDL_MUSTLOCK(s))
    SDL_UnlockSurface(s);
  
  return;
}

void ClearBuffer(Uint8 color)
{
  clearbuffer(screen, color);
}

void DisplayBuffer(int x, int y)
{
  SDL_UpdateRect(screen, 0, 0, 0, 0);
}

int CheckKey(SDLKey key)
{
  return ((event.type == SDL_KEYDOWN) && (event.key.keysym.sym == key));
}

void Init_all(int w, int h, int bpp, Uint32 flags)
{
  
  if ( SDL_Init(SDL_INIT_VIDEO) < 0 ) {
    fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());
    Quit("Error\n");
  }
  atexit(SDL_Quit);
  
  /* Set 640x480 video mode, 8 bpp */
  if ( (screen=SDL_SetVideoMode(w, h, bpp, flags)) == NULL ) {
    fprintf(stderr, "Couldn't set 640x480x8 video mode: %s\n", SDL_GetError());
    Quit("Error\n");
  }
  
  /* Set the surface pixels and refresh! */
  //  if ( SDL_LockSurface(screen) < 0 ) {
  //    fprintf(stderr, "Couldn't lock the display surface: %s\n",
  //	    SDL_GetError());
  //    Quit("Error\n");
  //  }
}   

void
rafraichirEcran ()
{
  //  WaitVR ();
  //  ClearBuffer(0);
  //  DisplayBuffer (0, 0);
  
  if (SDL_Flip(screen) == -1)
    printf("Error\n");
  
  ClearBuffer(1);
  if (nombreJoueurs < 2)
    PutPic (11, 0, 0);
  //  if (nombreJoueurs < 2)
  //    PutPic (11, 0, 0);
  //  else
  //Clearbuffer (0);
}
